#ifndef __MSimone__
#define __MSimone__

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>  

#include <iostream.h>
#include "TObject.h"
#include "TNtuple.h"

#include "COREventHeader.hxx"

//class MSimone : public TObject {
class MSimone {
 private:
  Float_t  PartId;        // Type of particle
  Float_t  Energy;       // Energy in GeV

  Float_t  Theta;        // Theta angle of event 
  Float_t  Phi;          // Phi angle of event 

  Float_t  CoreD;        // Core d pos
  Float_t  CoreX;        // Core x pos
  Float_t  CoreY;        // Core y pos

  Float_t  FirstInt ;    // First interaction in cm above sea level


 public:
  MSimone() ;         
  
  ~MSimone(); 

  void Clear();

  void Print(void);

  void Transfer ( COREventHeader *e );

  void NtupFill ( TNtuple *n ) ; 

  //  ClassDef(MSimone, 1)   //Stores Montecarlo Information 

};

#endif
